function ok = create_codeGen_files (appliPath, sdxPath, appliName)
rootOpName = codeGen_getProcName ();
compName = codeGen_getComputerName ();

ok = create_m4m_file (appliPath, appliName, rootOpName, compName) &..
    create_operatorM4x_file (appliPath, appliName, rootOpName)&..
    create_m4Appli_file (appliPath, appliName, rootOpName)&..
    create_makefile_file (appliPath, appliName, sdxPath, rootOpName);
endfunction

//****************************
// PATH PROCESSING
//****************************



// *********************************************************** //
// MISCELLANEOUS SYNDEX RELATED FILES
// *********************************************************** //
// this part must only be seen as debugging and fast testing code.

// m4m file processing
function ok = create_m4m_file (appliPath, appliName, rootOpName, computerName)
str = "define(`"+rootOpName+"_hostname_'', "+computerName+")dnl";
ok = cmn_writeToFile (appliPath + "/" + appliName + ".m4m" , str);
endfunction

function ok = create_operatorM4x_file (appliPath, appliName, rootOpName)
str = msprintf("include(%s.m4m)", appliName);
ok = cmn_writeToFile (appliPath + "/" + rootOpName + ".m4x", str);
endfunction

function ok = create_m4Appli_file (appliPath, appliName, rootOpName)
str = "include(syndex.m4m)dnl\n"+..
    "architecture_("+appliName+",\n"+..
    "SynDEx (c)INRIA 2004\n)\n\n"+..
    "processor_(U," + rootOpName + ",TCP,x,TCP,y)\n";
// when multiproc will be tested :
// processor_(U,pc1,TCP,x,TCP,y)
// connect_(TCP,link,root,x,pc1,x)
ok = cmn_writeToFile (appliPath + "/" + appliName + ".m4", str);
endfunction

// args:
// path, is the application path
// appName, is the application name
// sdxPath, is the path where SynDEx macros are located
// rootOpName, is the name of the root operator definition where to execute the application
function ok = create_makefile_file (path, appName, sdxPath, rootOpName)
str = "A  = " + appName + "\nM4 = gm4\n"+..
    "\n# these path have to be modified by user\n"+..
    "SDX_MACRO_PATH=" + sdxPath + "\n"+..
    "HERE=" + path + "\n"+..
    "export Macros_Path = $(SDX_MACRO_PATH)/Unix_C_TCP\n"+..
    "export Libraries_Path = $(SDX_MACRO_PATH)/libraries\n"+..
    "export S2s_Files_Path = $(HERE)/SCICOS_FILES\n"+..
    "export M4PATH = $(Macros_Path):$(Libraries_Path):$(S2s_Files_Path)\n"+..
    "\nCFLAGS = -DDEBUG -lm -Wall -pedantic\n"+..
    "\nVPATH = $(M4PATH)\n"+..
    ".PHONY: all clean cleanall cleantotal cleanc\n"+..
    "\n# replace " + rootOpName + ".c by $(A).run in order to run the application with a simple make call\n"+..
    "all : $(A).mk " + rootOpName + ".c\n"+..
    "\nclean ::\n"+..
    "	$(RM) \\#* *~ *.o *.a *.mnt " + rootOpName + " $(A).mk\n"+..
    "\ncleanall : clean\n"+..
    "	$(RM) " + rootOpName + ".m4\n"+..
    "\n# this rule is very dangerous. Use it when you want to retry the whole translation process\n"+..
    "cleantotal : cleanall\n"+..
    "	$(RM) $(A).* $(A)_sdc.m4x " + rootOpName + ".* \n"+..
    "\ncleanc : clean\n"+..
    "	$(RM) " + rootOpName + ".c\n"+..
    "\n$(A).mk : $(A).m4 syndex.m4m U.m4m $(A).m4m\n"+..
    "	$(M4) $< >$@\n"+..
    "\n\nroot.libs = \n"+..
    "p.libs = \n"+..
    "\n\n# the $(A).mk file is generated by the makefile process, do not edit/modify unless you know exactly what you are doing\n"+..
    "include $(A).mk\n";

ok = cmn_writeToFile (path+"/GNUmakefile", str);
endfunction