// /**************************************************/
// /**************************************************/




//*************** 
//**** S2S MAIN 
//*************** 
function s2sMain = S2S_createVoid_main ()
s2sMain = tlist(["S2S_main";..
	"blockList";"occurenceList";"definitionList";"clkEventList";"dataDepList";..
	"rootDefId";.. // main definition id
	"blockListLength";.. // number of blk
	],..
    list(), list(), list(), list(), list(),..
    -1,..
    -1);
endfunction

// occurence blocks : an occurence is a couple (scsBlk,clkEvent)
function s2sMain = S2S_addOccurence_main (s2sMain, occ)
s2sMain.occurenceList($+1) = occ;
endfunction
function occ = S2S_getOccurence_main (s2sMain, occId)
occ = s2sMain.occurenceList(occId);
endfunction
function id = S2S_getLastOccurenceId_main (s2sMain)
id = length(s2sMain.occurenceList);
endfunction

// number of scs blocks
function s2sMain = S2S_setBlockListLength_main (s2sMain, nb)
s2sMain.blockListLength = nb;
endfunction
function nb = S2S_getBlockListLength_main (s2sMain)
nb = s2sMain.blockListLength;
endfunction

// def related
function s2sDef = S2S_getDefinition_main (s2sMain, defId)
s2sDef = s2sMain.definitionList (defId);
endfunction
function s2sMain = S2S_addDefinition_main (s2sMain, s2sDef)
s2sMain.definitionList($+1) = s2sDef;
endfunction
function s2sMain = S2S_modifDefinition_main (s2sMain, newDef, defId)
s2sMain.definitionList(defId) = newDef;
endfunction
function id = S2S_getLastDefinitionId_main (s2sMain)
id = length(s2sMain.definitionList);
endfunction

// block related
function blk = S2S_getBlock_main (s2sMain, blkId)
blk = s2sMain.blockList (blkId);
endfunction
function s2sMain = S2S_addBlock_definition (s2sMain, blk)
s2sMain.blockList($+1) = blk;
endfunction
function s2sMain = S2S_modifBlock_main (s2sMain, newBlk, blkId)
s2sMain.blockList(blkId) = newBlk;
endfunction
function id = S2S_getLastBlockId_main (s2sMain)
id = length(s2sMain.blockList);
endfunction

// clk event related
function clkEvent = S2S_getClkEvent_main (s2sMain, clkEventId)
clkEvent = s2sMain.clkEventList(clkEventId);
endfunction
function s2sMain = S2S_addClkEvent_main (s2sMain, clkEvent)
s2sMain.clkEventList($+1) = clkEvent;
endfunction
function s2sMain = S2S_modifClkEvent_main (s2sMain, newClkEvent, clkId)
s2sMain.clkEventList(clkId) = newClkEvent;
endfunction
function id = S2S_getLastClkEventId_main (s2sMain)
id = length(s2sMain.clkEventList);
endfunction

function clkRootId = S2S_getClkRootId_main (s2sMain)
rootDefId = S2S_getRootDefinitionId_main (s2sMain);
clkRootId = S2S_getClkOutputId_logDef (s2sMain, rootDefId, 1);
endfunction

// root def related
function s2sMain = S2S_setRootDefinitionId_main (s2sMain, rootDefId)
s2sMain.rootDefId = rootDefId;
endfunction
function rootDef = S2S_getRootDefinitionId_main (s2sMain)
rootDef = s2sMain.rootDefId; // S2S_getDefinition_main (s2sMain, s2sMain.rootDefId);
endfunction

// data dep related
function s2sMain = S2S_addDataDep_main (s2sMain, dataDep)
s2sMain.dataDepList($+1) = dataDep;
endfunction
function dataDep = S2S_getDataDep_main (s2sMain, dataDepId)
dataDep = s2sMain.dataDepList(dataDepId);
endfunction
function id = S2S_getLastDataDepId_main (s2sMain)
id = length(s2sMain.dataDepList);
endfunction

//*******************
//**** S2S OCCURENCE
//*******************
// FULL POINTER
function occ = S2S_create_occurence (blkId, clkId)
occ = tlist(["S2s_occurence";"s2sBlockId";"clkEventId"],..
    blkId, clkId);
endfunction

function blkId = S2S_getBlkId_occurence (s2sMain, occId)
occ = S2S_getOccurence_main (s2sMain, occId);
blkId = occ.s2sBlockId;
endfunction
function clkId = S2S_getClkId_occurence (s2sMain, occId)
occ = S2S_getOccurence_main (s2sMain, occId);
clkId = occ.clkEventId;
endfunction

function str = S2S_getDefinitionName_occurence (s2sMain, occId)
blkId = S2S_getBlkId_occurence (s2sMain, occId);
str = S2S_getDefinitionName_block (s2sMain, blkId);
endfunction

function str = S2S_getReferenceName_occurence (s2sMain, occId)
scsId = S2S_getBlkId_occurence (s2sMain, occId);
clkId = S2S_getClkId_occurence (s2sMain, occId);
str = cmn_getReferenceName (funName, scsId, clkId);
endfunction

//***************
//**** S2S DEFINITION : interface object
//***************
function s2sDef = S2S_createVoid_definition(defType)
s2sDef = tlist([defType;..
	"funName";"iPortList";"oPortList";.. // s2s definition core
	"defType";"isContinuous";.. // s2s standard definition
	"clkOutIdList";"s2sBlockId";"proxyDataList".. // s2s logical definition
	],.. 
    emptystr(), list(), list(),..
    emptystr(), %F,..
    list(), -1, []);
endfunction

//** constant: definition tlist types
function str = S2S_getTlistType_logDef ()
str = "S2s_logicalDefinition";
endfunction
function str = S2S_getTlistType_stdDef ()
str = "S2s_standardDefinition";
endfunction

//** CORE DEFINITION functions
// may NOT be used and processed unless its type is set as log or std
function s2sDef = S2S_createVoid_defCore()
s2sDef = S2S_createVoid_definition(emptystr());
endfunction
function s2sDef = S2S_build_defCore (name, iPorts, oPorts)
s2sDef = S2S_createVoid_defCore();
s2sDef.funName = name;
s2sDef.iPortList = iPorts;
s2sDef.oPortList = oPorts;
endfunction


//* name def building for s2sMain
function s2sDefName = S2S_getName_definition (s2sMain, defId)
// s2sDef = S2S_getDefinition_main (s2sMain, defId)
funName = S2S_getFunName_definition (s2sMain, defId); //s2sDef.funName;

if S2S_isLogical_definition (s2sMain, defId) then 
  scsId = S2S_getScsId_logDef (s2sMain, defId);
  s2sDefName = S2S_buildLogDefinitionName (funName, scsId)
else
  s2sDef = S2S_getDefinition_main (s2sMain, defId);
  iPorts = s2sDef.iPortList; oPorts = s2sDef.oPortList;
  s2sDefName = S2S_buildStdDefinitionName (funName, iPorts, oPorts)
end
endfunction


//** def core handles
function s2sDef = S2S_setDefinitionName_definition (s2sMain, s2sDefId, name)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
s2sDef.funName = name;
s2sMain = S2S_modifDefinition_main (s2sMain, s2sDef, s2sDefId);
endfunction
function name = S2S_getFunName_definition (s2sMain, defId)
def = S2S_getDefinition_main (s2sMain, defId);
name = def.funName;
endfunction

// unused functions for now
function s2sMain = S2S_setIportList_definition (s2sMain, s2sDefId, iPorts)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
s2sDef.iPortList = iPorts;
s2sMain = S2S_modifDefinition_main (s2sMain, s2sDef, s2sDefId);
endfunction
function s2sMain = S2S_setOportList_definition (s2sMain, s2sDefId, oPorts)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
s2sDef.oPortList = oPorts;
s2sMain = S2S_modifDefinition_main (s2sMain, s2sDef, s2sDefId);
endfunction

function iPortList = S2S_getIportList_definition (s2sMain, defId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
iPortList = s2sDef.iPortList;
endfunction
function oPortList = S2S_getOportList_definition (s2sMain, defId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
oPortList = s2sDef.oPortList;
endfunction
function psize = S2S_getOportSize_definition (s2sMain, defId, oPtId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
psize = s2sDef.oPortList(oPtId);
endfunction
function psize = S2S_getIportSize_definition (s2sMain, defId, iPtId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
psize = s2sDef.iPortList(iPtId);
endfunction




function s2sDef = S2S_setLogical_defCore (s2sDef)
s2sDef(1)(1) = S2S_getTlistType_logDef ();
endfunction
function s2sDef = S2S_setStandard_defCore (s2sDef)
s2sDef(1)(1) = S2S_getTlistType_stdDef ();
endfunction
function isLogical = S2S_isLogical_definition (s2sMain, s2sDefId)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
isLogical = (typeof(s2sDef) == S2S_getTlistType_logDef ());
endfunction


//** for continuous time management
// not maanged by pointer because the data is filled during the def construction
function s2sDef = S2S_setContinuous_definition (s2sDef, bool)
s2sDef.isContinuous = bool;
endfunction
function isContinuous = S2S_isContinuous_definition (s2sMain, s2sDefId)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
isContinuous = s2sDef.isContinuous;
endfunction


//** S2S LOGICAL DEFINITION : inherits definition
function s2sDef = S2S_createVoid_logDef ()
s2sDef = S2S_createVoid_definition(S2S_getTlistType_logDef ());
endfunction
//** S2S STANDARD DEFINITION : inherits definition
function s2sDef = S2S_createVoid_stdDef ()
s2sDef = S2S_createVoid_definition(S2S_getTlistType_stdDef ());
endfunction






//****************************
//** log def related functions
//
// note that a logDef <=> DAG node

// related scs block
function scsId = S2S_getScsId_logDef (s2sMain, defId)
//could test if is log def
s2sDef = S2S_getDefinition_main (s2sMain, defId);
scsId = s2sDef.s2sBlockId;
endfunction


// clkParent
function clkId = S2S_getClkParentId_logDef (s2sMain, defId)
if defId == S2S_getRootDefinitionId_main (s2sMain) then
  error("Root definition has no clk parent");
end
scsId = S2S_getScsId_logDef (s2sMain, defId)
clkEventList = S2S_getOccIdList_block (s2sMain, scsId);
if length(clkEventList) > 1 then
  str = msprintf("logDef %d multi activated",defId);
  error(str);
end
occId = clkEventList(1);
clkId = S2S_getClkId_occurence (s2sMain, occId);
endfunction
// output clkEvent related
function clkIdList = S2S_getClkOutputIdList_logDef (s2sMain, defId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
clkIdList = s2sDef.clkOutIdList;
endfunction
function nb = S2S_getClkOutputListLength_logDef (s2sMain, defId)
nb = length(S2S_getClkOutputIdList_logDef (s2sMain, defId));
endfunction
function clkId = S2S_getClkOutputId_logDef (s2sMain, defId, clkNumber)
clkList = S2S_getClkOutputIdList_logDef (s2sMain, defId);
clkId = clkList(clkNumber);
endfunction


//* proxyDataList is : blkId -> [ptId;bool] list
//* representing if the logDef need to proxify blkId/ptId and get 
//  the data ramanent
// PURE POINTER, (26/05/05) proxy port related

// constants
function pxType = S2S_NCA_proxyType ()
pxType = 0;
endfunction
function pxType = S2S_propagation_proxyType ()
pxType = 1;
endfunction
function pxType = S2S_dispatching_proxyType ()
pxType = 2;
endfunction

function s2sMain = S2S_initProxyDataList_logDef (s2sMain, logDefId)
proxyList = list(); // S2S_getProxyDataList_logDef (s2sMain, logDefId);
for i=1:S2S_getBlockListLength_main (s2sMain)
  proxyList(i) = list();
end
s2sDef = S2S_getDefinition_main (s2sMain, logDefId);
s2sDef.proxyDataList = proxyList;
s2sMain = S2S_modifDefinition_main (s2sMain, s2sDef, logDefId);
endfunction

function proxyList = S2S_getProxyDataList_logDef (s2sMain, defId)
s2sDef = S2S_getDefinition_main (s2sMain, defId);
proxyList = s2sDef.proxyDataList;
endfunction

function ok = S2S_hasProxyData_logDef (s2sMain, defId, blkId, oPtId)
ok = %F;
proxyList = S2S_getProxyDataList_logDef (s2sMain, defId);
if isempty(proxyList(blkId)) then // void list : no proxy defined yet
  return;
else // blk has 1+ pt proxified
  ptProxyIdList = proxyList(blkId);
  for ptProxy=ptProxyIdList // look for this one
    if ptProxy(1) == oPtId then // look only at the port id, NCA does not matter
      ok = %T; return;
    end
  end
end
endfunction

// check if defId is NCA of blkId/oPtId
function ok = S2S_hasRemanentData_logDef (s2sMain, defId, blkId, oPtId)
ok = %F;
proxyList = S2S_getProxyDataList_logDef (s2sMain, defId);
if isempty(proxyList(blkId)) then // void list : no proxy defined yet
  return;
else // blk has 1+ pt proxified
  ptProxyIdList = proxyList(blkId);
  for ptProxy=ptProxyIdList // look for this one
    if ptProxy(1) == oPtId & ptProxy(2) == S2S_NCA_proxyType () then
      ok = %T; return;
    end
  end
end
endfunction

// proxy data means the sdxLogDef will have an i and o port 'proxyfying' blkId/ptId
// If proxyType ==0, it is NCA there will be a delay 'around' it in the clkParent
// if proxyType ==1, it is a propagating proxy data (i AND o ports added)
// if proxyType ==2, it is just an input port for dispatching (only i)
// NO CHECK
function s2sMain = S2S_addProxyData_logDef (s2sMain, logDefId, blkId, ptId, proxyType)
s2sDef = S2S_getDefinition_main (s2sMain, logDefId);

proxyList = S2S_getProxyDataList_logDef (s2sMain, logDefId);
ptList = proxyList(blkId);
ptList($+1) = list(ptId,proxyType);
proxyList(blkId) = ptList;
s2sDef.proxyDataList = proxyList;

s2sMain = S2S_modifDefinition_main (s2sMain, s2sDef, logDefId);
endfunction





//***************
//**** CLK EVENTS
//***************
function clkEvent = S2S_create_clkEvent (defId)
clkEvent = tlist(["S2s_clkEvent";..
	"s2sDefId";"occIdList";"dataManagementList"],..
    defId,.. // source definition (DAG node)
    list(),.. // will be filled while clkMat scan
    list()); // will be filled while datadep processing
endfunction

function clkEvent = S2S_addOccId_clkEvent (clkEvent, occId)
clkEvent.occIdList($+1) = occId;
endfunction
function defId = S2S_getDefId_clkEvent (s2sMain, clkId)
clkEvent = S2S_getClkEvent_main (s2sMain, clkId);
defId = clkEvent.s2sDefId;
endfunction
function occIdList = S2S_getOccIdList_clkEvent (s2sMain, clkId)
clkEvent = S2S_getClkEvent_main (s2sMain, clkId);
occIdList = clkEvent.occIdList;
endfunction


function ok = S2S_occurenceExists_clkEvent (s2sMain, clkId, occId)
occIdList = S2S_getOccIdList_clkEvent (s2sMain, clkId);
ok = isInList (occIdList, occId);
endfunction

// check if an occurence of blkId exists in clkId
function ok = S2S_blkOccurenceExists_clkEvent (s2sMain, clkId, blkId)
occIdList = S2S_getOccIdList_clkEvent (s2sMain, clkId);
//scan for each occ if its block id is blkId
for occId=occIdList
  if blkId == S2S_getBlkId_occurence (s2sMain, occId) then // found
    ok = %T; return;
  end
end
ok = %F;
endfunction


//***
//** (26/05/05) data management related structure and functions
/// PURE POINTER,
//** PURE POINTER, blk+port dataManagement struct + fct
function pdm = S2S_createVoid_dataManagement ()
pdm = tlist(["S2S_dataManagement";..
	"dispatchToList";"dispatchDownList";.. // direct link to dest or logblk not in propagation method
	"propagationMethod"],.. // used for data propagation
    list(), list(),.. // [blkId;ptId;method] list ; [logDefId;method] list
    emptystr()); // -1:propagate, 0:bring data up, >0:carryThrough logBlkId, empty:no propagation
endfunction



function s2sMain = S2S_initDataManagementList_clkEvent (s2sMain, clkId)
// in this clkEvent,
blkDataList = list(); // S2S_getDataManagementList_clkEvent (s2sMain, clkId);
for i=1:S2S_getBlockListLength_main (s2sMain) // for each scsBlk
  dataPortList = list();
  // retrieve block s number of o ports
  oPtListSize = length (S2S_getOportList_block (s2sMain, i));
  for j=1:oPtListSize // init the pt ptr with a void dataM
    dataPortList(j) = S2S_createVoid_dataManagement ();
  end
  blkDataList(i) = dataPortList;
end

clkEvent = S2S_getClkEvent_main (s2sMain, clkId);
clkEvent.dataManagementList = blkDataList;
s2sMain = S2S_modifClkEvent_main (s2sMain, clkEvent, clkId); // modif clkEvent
endfunction

// inner function to modify a dataManagement
function s2sMain = S2S_modifDataManagement_clkEvent (s2sMain, clkId, blkId, ptId, dataM)
clkEvent = S2S_getClkEvent_main (s2sMain, clkId); // get clkEvent
blkDataM = clkEvent.dataManagementList(blkId); // get dataM list for blkId
blkDataM(ptId) = dataM; // replace dataM for pt ptId with the new dataM
clkEvent.dataManagementList(blkId) = blkDataM; // replace dataM list with the new
s2sMain = S2S_modifClkEvent_main (s2sMain, clkEvent, clkId); // modif clkEvent
endfunction

// handle functions for dataManagement structures
function blkDmList = S2S_getDataManagementList_clkEvent (s2sMain, clkId)
clkEvent = S2S_getClkEvent_main (s2sMain, clkId);
blkDmList = clkEvent.dataManagementList;
endfunction
function dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId)
dmList = S2S_getDataManagementList_clkEvent (s2sMain, clkId);
dmBlk = dmList(blkId);
dm = dmBlk(ptId);
endfunction



//*******************
//** DATA PROPAGATION

//* modify the data propagation method for blkId/ptId
// NO CHECK HERE
// factorization functions and constant acces (should be 'private')
function s2sMain = S2S_dataManagement_factorize (s2sMain, clkId, blkId, ptId, value)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
dm.propagationMethod = value;
s2sMain = S2S_modifDataManagement_clkEvent (s2sMain, clkId, blkId, ptId, dm);
endfunction
function value = S2S_getPropagateData_const ()
value = -1;
endfunction
function value = S2S_getBringUpData_const ()
value = 0;
endfunction
// public data management functions
// ADD functions
function s2sMain = S2S_propagateData_clkEvent (s2sMain, clkId, blkId, ptId)
s2sMain = S2S_dataManagement_factorize (s2sMain, clkId, blkId, ptId,..
    S2S_getPropagateData_const ());
endfunction
function s2sMain = S2S_bringUpData_clkEvent (s2sMain, clkId, blkId, ptId)
s2sMain = S2S_dataManagement_factorize (s2sMain, clkId, blkId, ptId,..
    S2S_getBringUpData_const ());
endfunction
function s2sMain = S2S_carryThroughData_clkEvent (s2sMain, clkId, blkId, ptId, logBlkId)
s2sMain = S2S_dataManagement_factorize (s2sMain, clkId, blkId, ptId,..
    logBlkId); // always >0
endfunction
// GET functions
function ok = S2S_dataPropagationExists_clkEvent(s2sMain, clkId, blkId, ptId)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
ok = ~isempty(dm.propagationMethod);
endfunction
function ok = S2S_isDataPropagated_clkEvent (s2sMain, clkId, blkId, ptId)
if ~S2S_dataPropagationExists_clkEvent(s2sMain, clkId, blkId, ptId) then
  ok = %F;
else
  dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
  ok = (dm.propagationMethod == S2S_getPropagateData_const ());
end
endfunction

function ok = S2S_isDataCarriedThrought (s2sMain, clkId, blkId, ptId, logBlkId)
if ~S2S_dataPropagationExists_clkEvent(s2sMain, clkId, blkId, ptId) then
  ok = %F;
else
  dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
  ok = (dm.propagationMethod == logBlkId);
end
endfunction

// check if data is 'proxified' in a log blk (by propagation or remanence) 
// 0  : not found
// >0 : logBlkId
function logBlkId = S2S_lookForCarryingLogBlk_clkEvent (s2sMain, clkId, blkId, ptId)
clkOccList = S2S_getOccIdList_clkEvent (s2sMain, clkId);
i=1;logBlkId = 0;
while i <= length(clkOccList) & logBlkId == 0
  occ = clkOccList(i);
  logBlk = S2S_getBlkId_occurence (s2sMain, occ);
  if S2S_isLogical_block (s2sMain, logBlk) then
    // data may be carried through logBlk
    if S2S_isDataCarriedThrought (s2sMain, clkId, blkId, ptId, logBlk) then
      mprintf("data %d/%d carried through logBlk %d in clkId %d\n",blkId, ptId, logBlk, clkId);
      logBlkId = logBlk; return;
    end
    
    // if not, it can be proxified
    defLogBlk = S2S_getDefinitionId_block (s2sMain, logBlk);
    if S2S_hasRemanentData_logDef (s2sMain, defLogBlk, blkId, ptId);
      mprintf("data %d/%d proxified by logBlk %d in clkId %d\n",blkId, ptId, logBlk, clkId);
      logBlkId = logBlk; return;
    end
  end
  i = i+1;
end
endfunction

//note that function  isDataBroughtUp is useless


//*******************
//** DATA DISPATCHING

function d = S2S_localProxyLink_dispatch ()
d = -1;
endfunction
function d = S2S_directLink_dispatch ()
d = 0;
endfunction
//* once propagated to motherDef, data can be dispatched to blk / down the logDefs
// we dispatch data from blkId,ptId TO destBlkId,destPtId
//* dispatchMethod can receive 3 values :
//  -1 : data from local proxy port (dest underactivated or exclusive)
//   0 : direct link (srcOcc, present)
//  >0 : data from logBlk proxy port (dest overactivated or dest //)
function s2sMain = S2S_dispatchTo_clkEvent (s2sMain,..
    clkId, blkId, ptId, destBlkId, destPtId, dispatchMethod)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
dm.dispatchToList($+1) = list(destBlkId,destPtId,dispatchMethod);
s2sMain = S2S_modifDataManagement_clkEvent (s2sMain, clkId, blkId, ptId, dm);
endfunction
// TODO: read and get functions

//* dispatch data down to 'downToLogBlkId'
//* dispatchMethod can receive 3 values :
//  -1 : data from local proxy port (dest underactivated or exclusive)
//   0 : direct link (srcOcc, present)
//  >0 : data from logBlk proxy port (dest overactivated or dest //)
function s2sMain = S2S_dispatchDown_clkEvent (s2sMain,..
    clkId, blkId, ptId, downToLogBlkId, dispatchMethod)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
dm.dispatchDownList($+1) = list(downToLogBlkId,dispatchMethod);
s2sMain = S2S_modifDataManagement_clkEvent (s2sMain, clkId, blkId, ptId, dm);
endfunction

// check if data has already been dispatched down
//  there is never two links to a same destBlk/destPt)
// (note you never have to test for 'dispachedTo' before adding.
//  2 links to the same destBlk/destPt does not exist)
function ok = S2S_isDataDispatchedDown (s2sMain, clkId, blkId, ptId, logBlkId)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, blkId, ptId);
for dispatch=dm.dispatchDownList
  if dispatch(1) == logBlkId then
    ok = %T; return;
  end
end
ok=%F;
endfunction

// DEBUG function because we never dispatchTo more than 1 time
function ok = S2S_isDispatchedTo (s2sMain,clkId,..
    fromBlk,fromPt,toBlk,toPt)
dm = S2S_getDataManagement_clkEvent (s2sMain, clkId, fromBlk, fromPt);
for dispatch=dm.dispatchToList
  if dispatch(1) == toBlk & dispatch(2) == toPt then
    ok = %T; return;
  end
end
endfunction


//*************** 
//**** S2S blocks
//*************** 
function blk = S2S_create_block(defId, paramList)
blk = tlist(["S2s_block";..
	"parameterValueList";"occIdList";"s2sDefId";..
	"outDataDepIdList"],..
    paramList,..
    list(),.. // will be filled while clkMat scan
    defId,..
    list()); // will be filled while dataMat scan
endfunction

function blk = S2S_addOccId_block (blk, occId)
blk.occIdList($+1) = occId;
endfunction
function occIdList = S2S_getOccIdList_block (s2sMain, blkId)
blk = S2S_getBlock_main (s2sMain, blkId);
occIdList = blk.occIdList;
endfunction
function nb = S2S_getOccListLength_block (s2sMain, blkId)
occIdList = S2S_getOccIdList_block (s2sMain, blkId);
nb = length(occIdList);
endfunction

function isLogical = S2S_isLogical_block (s2sMain, blkId)
blkDefId = S2S_getDefinitionId_block (s2sMain, blkId);
isLogical = S2S_isLogical_definition (s2sMain, blkDefId);
endfunction
// we assume the blk is fully built (def must be filled)
function str = S2S_getDefinitionName_block (s2sMain, blkId)
s2sDefId = S2S_getDefinitionId_block (s2sMain, blkId);
str = S2S_getName_definition (s2sMain, s2sDefId);
endfunction
function funName = S2S_getFunName_block (s2sMain, blkId)
s2sDefId = S2S_getDefinitionId_block (s2sMain, blkId);
funName = S2S_getFunName_definition (s2sMain, s2sDefId);
endfunction

function s2sDefId = S2S_getDefinitionId_block (s2sMain, blkId)
blk = S2S_getBlock_main (s2sMain, blkId);
s2sDefId = blk.s2sDefId;
endfunction

function paramList = S2S_getParameterValueList_block (s2sMain, blkId)
blk = S2S_getBlock_main (s2sMain, blkId);
paramList = blk.parameterValueList;
endfunction

// port related functions (shortcuts to def functions)
function iPortList = S2S_getIportList_block (s2sMain, blkId)
defId = S2S_getDefinitionId_block (s2sMain, blkId);
iPortList = S2S_getIportList_definition (s2sMain, defId);
endfunction
function oPortList = S2S_getOportList_block (s2sMain, blkId)
defId = S2S_getDefinitionId_block (s2sMain, blkId)
oPortList = S2S_getOportList_definition (s2sMain, defId);
endfunction
function psize = S2S_getOportSize_block (s2sMain, blkId, oPtId)
defId = S2S_getDefinitionId_block (s2sMain, blkId);
psize = S2S_getOportSize_definition (s2sMain, defId, oPtId);
endfunction
function psize = S2S_getIportSize_block (s2sMain, blkId, iPtId)
defId = S2S_getDefinitionId_block (s2sMain, blkId);
psize = S2S_getIportSize_definition (s2sMain, defId, iPtId);
endfunction


// datadep related
function blk = S2S_addOutDataDep_block (blk, depId)
blk.outDataDepIdList($+1) = depId;
endfunction
function outDataDepIdList = S2S_getOutDataDepIdList_block (s2sMain, blkId)
blk = S2S_getBlock_main (s2sMain, blkId);
outDataDepIdList = blk.outDataDepIdList;
endfunction


function name = S2S_getReferenceName_block (s2sMain, blkId, clkId)
s2sDefId = S2S_getDefinitionId_block (s2sMain, blkId);
funName = S2S_getFunName_definition (s2sMain, s2sDefId);
name = cmn_getReferenceName (funName, blkId, clkId); // for proxy ports
endfunction

//function name = S2S_getReferenceName_logDef (s2sMain, defId)
//funName = S2S_getFunName_definition (s2sMain, defId);
//clkId = S2S_getClkParentId_logDef (s2sMain, currDefId);
//scsId = S2S_getScsId_logDef (s2sMain, defId);
//name = cmn_getReferenceName (funName, scsId, clkId);
//endfunction
//function name = S2S_getReferenceName_occurence (s2sMain, occId)
//scsId = S2S_getBlkId_occurence (s2sMain, occId);
//funName = S2S_getFunName_definition (s2sMain, scsId);
//clkId = S2S_getClkId_occurence (s2sMain, occId);
//name = cmn_getReferenceName (funName, scsId, clkId);
//endfunction



//******************
//**** S2S data dep
//******************

function dataDep = S2S_create_dataDep (srcBlkId, srcPtId, destBlkId, destPtId)
dataDep = tlist(["S2s_dataDep";..
	"srcBlkId";"srcPtId";"destBlkId";"destPtId"],..
    srcBlkId, srcPtId, destBlkId, destPtId);
endfunction

// factorization
function id = S2S_getField_dataDep (s2sMain, dataDepId, fieldName)
dataDep = S2S_getDataDep_main (s2sMain, dataDepId);
id = dataDep(fieldName);
endfunction
// public functions
function id = S2S_getSrcBlkId_dataDep (s2sMain, dataDepId)
id = S2S_getField_dataDep (s2sMain, dataDepId, "srcBlkId");
endfunction
function id = S2S_getDestBlkId_dataDep (s2sMain, dataDepId)
id = S2S_getField_dataDep (s2sMain, dataDepId, "destBlkId");
endfunction
function id = S2S_getSrcPortId_dataDep (s2sMain, dataDepId)
id = S2S_getField_dataDep (s2sMain, dataDepId, "srcPtId");
endfunction
function id = S2S_getDestPortId_dataDep (s2sMain, dataDepId)
id = S2S_getField_dataDep (s2sMain, dataDepId, "destPtId");
endfunction


//********************
//** NCA PROCESSING
//********************

//* Const functions defining the type of NCA found
function NCAtype = S2S_srcOversampled_nca () 
NCAtype = 0; 
endfunction
function NCAtype = S2S_srcExclusive_nca ()
NCAtype = 1; 
endfunction
function NCAtype = S2S_destOversampled_nca ()
NCAtype = 2; 
endfunction
function NCAtype = S2S_destExclusive_nca ()
NCAtype = 3; 
endfunction
function NCAtype = S2S_destParallel_nca ()
NCAtype = 4; 
endfunction
function NCAtype = S2S_empty_nca ()
NCAtype = -1; 
endfunction // should not happen

//* test functions on the type
function ok = S2S_isSrcOversampled_nca (NCAtype) 
ok = (NCAtype==S2S_srcOversampled_nca ()); 
endfunction
function ok = S2S_isSrcExclusive_nca (NCAtype) 
ok = (NCAtype==S2S_srcExclusive_nca ()); 
endfunction
function ok = S2S_isDestOversampled_nca (NCAtype)
ok = (NCAtype==S2S_destOversampled_nca ()); 
endfunction
function ok = S2S_isDestExclusive_nca (NCAtype)
ok = (NCAtype==S2S_destExclusive_nca ()); 
endfunction
function ok = S2S_isDestParallel_nca (NCAtype) 
ok = (NCAtype==S2S_destParallel_nca ()); 
endfunction
function ok = S2S_isEmpty_nca (NCAtype) 
ok = (NCAtype==S2S_empty_nca ()); 
endfunction



function ok = S2S_isNcaNeeded_nca (NCAtype)
ok = (~(NCAtype==S2S_empty_nca()) & ~(NCAtype==S2S_srcOversampled_nca()));
endfunction

//**
// GET NCA
// Returns the id in the activation table where the clkIds of src and/or dest differ
// args:
// NCArowId, is the rowId of a srcActPath where the logDef will be NCA of src
// NCAtype, is the type of 'difference' notified
//
// * WARNING: we do not test the case where each occ(dest) has the same activation of one occ(src)
// *   We assume when src is multiactivated -> need of remanence

// note there are no srcOcc activated by root here
//      there are no srcOcc equal/over activated for each destOcc
//
// there are 4 cases to be encountered here (2 solutions) :
// - dest overactivated           : return rowId-1
// - srcExclusive or 
//   destOcc exclusive with src or
//   destOcc not related with src : return rowId
//
function [NCArowId,NCAtype] = S2S_getNca (s2sMain, occActivationPathList, srcOccIdList, destDataList)
mprintf("NCA PROCESSING, src blk:%d\n",srcBlkId);

NCArowId = []; 
NCAtype = S2S_empty_nca ();

// get src block activation table
rowId = 1; idMax = S2S_getLastClkEventId_main (s2sMain);

// TODO:
// first, check if exists a destOcc activated by clkRoot. 
// If yes, the remanence must be on the first logDef 
// activated by clkRoot


//*** we advance into the activation path
while rowId <= idMax
  currClkId = [];
  mprintf("-rowId:%d, ",rowId);
  
  //** SRC processing at rowId
  // if possible get the 'reference' clkId

  firstSrcActPath = occActivationPathList(srcOccIdList(1));
  if size(firstSrcActPath) < rowId then // if reached, should ALWAYS be mono activated
    str = msprintf("src overactivated : this point should not be reached");
    error(str);
  end
  currClkId = firstSrcActPath(rowId);
  mprintf("currClkId:%d\n",currClkId);
  // test for src potential other activations (see WARNING as there will obviously be a NCA)
  for i=2:length(srcOccIdList)
    mprintf("_Multiactivated src_");
    srcActivationPath = occActivationPathList(srcOccIdList(i));//srcActivationTable(i);
    srcClkId = srcActivationPath(rowId);
    // activations differ at rowId (activations have to be clk exclusive)
    if srcClkId ~= currClkId then
      // return the common defIf of srcClkId and currClkId
      mprintf("clkId(%d) of srcBlk differs\n",srcClkId);
      NCArowId = rowId;
      NCAtype = S2S_srcExclusive_nca ();
      return;
    else
      mprintf(" (common srcClkId:%d : ok)\n",srcClkId);
    end
  end
  
  //** DEST occurences actPath processing at rowId
  for destData=destDataList
    destOcc = destData(1); // destData(2) is the destPtId
    destActivationPath = occActivationPathList(destOcc);

    mprintf("process destOcc %d(blkId:%d) :",destOcc, S2S_getBlkId_occurence (s2sMain, destOcc));
    // for each dest blk, test each activation
    if size(destActivationPath) >= rowId then
      destClkId = destActivationPath(rowId);
      mprintf("%d:", destClkId);
      if destClkId ~= currClkId then
	mprintf("differs, type: ");
	currClkDef = S2S_getDefId_clkEvent (s2sMain, currClkId);
	destClkDef = S2S_getDefId_clkEvent (s2sMain, destClkId);
	if currClkDef == destClkDef then //if differs with same logDef -> exclusive
	  mprintf("exclusive");
	  NCAtype = S2S_destExclusive_nca ();
	else 
	  mprintf("not exclusive");
	  NCAtype = S2S_destParallel_nca ();
	end
	mprintf(" => found\n");
	NCArowId = rowId; // currClkDef;
	return;
      end
      mprintf("ok ");
    else // dest over sampled, NCA is the defId of destActivationPath(rowId -1)
      // MODIFS : try with rowId without '-1'
      NCArowId = rowId; // S2S_getDefId_clkEvent (s2sMain, destActivationPath(rowId -1));
      NCAtype = S2S_destOversampled_nca ();
      mprintf("oversampled => found\n");
//TODO: test without 'return'
      return;
    end
    mprintf(".\n");    
  end
  mprintf("next rowId...\n");
  rowId = rowId +1;
end

//* WARNING: we should not be able to reach this point !
if NCAtype ~= S2S_destOversampled_nca () then
  error ("no NCA found : this point should not be reached");
end
endfunction

// partition destination list into 3 disjoint lists of OCCURENCEs :
// equalsampledOccList,   is a list of : list(destOcc,ptId)
// subsampledOccList, is a list of : list(destOcc,ptId)
// occList, is the rest and is a list of list(destOcc,ptId)
function [equalsampledOccList,subsampledOccList,occList] =..
    S2S_partitionDest (s2sMain, dataDepIdList)
mprintf("++ in : S2S_partitionDest ++\n");
equalsampledOccList = list();
subsampledOccList = list();
occList = list();

// retrieve the occ list of src via a dataDep (srcPt is not relevant here)
sampleDep = dataDepIdList(1);
srcBlkId = S2S_getSrcBlkId_dataDep (s2sMain, sampleDep); 
srcClkOccList = S2S_getOccIdList_block (s2sMain, srcBlkId);

nbSrcOcc = S2S_getOccListLength_block (s2sMain,srcBlkId );

mprintf("++ srcBlkId:%d,  nbSrcOcc:%d (%s) ++\n",..
    srcBlkId,nbSrcOcc,S2S_getDefinitionName_block (s2sMain, srcBlkId));

// foreach outgoing dataDep
for dataDepId = dataDepIdList
  // get destBlkId
  destBlkId = S2S_getDestBlkId_dataDep (s2sMain, dataDepId);
  destPtId = S2S_getDestPortId_dataDep (s2sMain, dataDepId);
  // get its occurences id
  occListId = S2S_getOccIdList_block (s2sMain, destBlkId);

  mprintf("-- dataDepId=%d, dest:%d/%d, nbDestOcc:%d\n",..
      dataDepId,..
      destBlkId, S2S_getDestPortId_dataDep (s2sMain, dataDepId),..
      length(occListId));
  
  //foreach occ,
  for destOccId = occListId
    // destData will be added in one of the three lists
    destData = list(destOccId, destPtId);
    // get dest clkId
    destClkId = S2S_getClkId_occurence (s2sMain, destOccId);

    mprintf("-  dest occ:%d, clkId:%d (destName:%s)\n",..
	destOccId,destClkId,S2S_getDefinitionName_occurence (s2sMain, destOccId));
    
    //* compare with each src clkId to see if exists an 
    //* equally/Xor/over sampled srcClkId
    // note we do not check anything else (not related or exclusive)
    i = 1; sampleType = -1;
    while sampleType == -1 & i <= nbSrcOcc // while no srcOcc found or endoflist
      // get src ClkId via the current src occ
      srcOccId = srcClkOccList(i);
      srcClkId = S2S_getClkId_occurence (s2sMain, srcOccId);
      mprintf("   srcOcc:%d, clkId:%d ==> sType=",srcOccId,srcClkId);
      // get sampleType according to the two clkIds
      sampleType = S2S_partitionLoop (s2sMain,srcClkId,destClkId);
      
      mprintf("%d (%s)\n",sampleType,S2S_getDefinitionName_occurence (s2sMain, srcOccId));

      // equal/over activated src occ found, filling related list
      select sampleType, // sampleType= -1:standard type, 0:equal, 1:_src_ oversampled
      case 0 then
	equalsampledOccList($+1) = destData; //*** adding destData ***//
      case 1 then
	subsampledOccList($+1) = destData; //*** adding destData ***//
      else
	i = i+1;
      end
    end // end srcOcc scan
     // no srcOcc equal/over sampled found
    if sampleType == -1 then
      occList($+1) = destData; //*** adding destData ***//
    end
  end // end destOcc scan
end // end dataDep scan
endfunction

// -1:standard type, 0:equal, 1:_src_ oversampled
function sampleType = S2S_partitionLoop (s2sMain,srcClkId,destClkId)
clkRootId = S2S_getClkRootId_main (s2sMain);
sampleType = -1
str = emptystr();

//*1* : check equality
if srcClkId == destClkId then 
  mprintf("equal!"); sampleType = 0; return,
end
//*2* first : if srcActivation is root => over sampled
if srcClkId == clkRootId then
  mprintf("src OverSampled!");  sampleType = 1; return;
end

//*2* next : check oversampling of _src_ on dest
// by going up the actPath of destOcc (start at destClkId)
currClkId = destClkId; 
mprintf("(%d =? clks[",srcClkId);
while currClkId ~= clkRootId // if rootId is reached -> sampleType=0
  mprintf("%d ",currClkId);
  if srcClkId == currClkId then // if srcClk found -> src overActivated
    sampleType = 1;
    mprintf("]");
    return;
  end
  // going up the hierarchy
  currDefId = S2S_getDefId_clkEvent (s2sMain, currClkId);
  currClkId = S2S_getClkParentId_logDef (s2sMain, currDefId);
end // end go up in destActPath
mprintf("]");
endfunction



//************************************************
//********* relation between clkEvents
//************************************************

// this function is far from optimal but since logBlk has few clkOutputs
// it is acceptable
function brotherIdList = S2S_getClkBrotherIdList_clkEvent (s2sMain, clkId)
brotherIdList = list();
// get logDef
defId = S2S_getDefId_clkEvent (s2sMain, clkId);
clkIdList = S2S_getClkOutputIdList_logDef (s2sMain, defId);

for id=clkIdList
  if id ~= clkId then
    brotherIdList($+1) = id;
  end
end
endfunction


function sdxtype = S2S_getSdxType_definition (s2sMain, s2sDefId)
s2sDef = S2S_getDefinition_main (s2sMain, s2sDefId);
sdxtype = s2sDef.defType;

// MODIF 10/01/06 : already computed in s2s_translation L93
//if S2S_isLogical_definition (s2sMain, s2sDefId) then
//  sdxtype = "algorithm"; return;
//end
//if S2S_getFunName_definition (s2sMain, s2sDefId) == "dollar" then
//  sdxtype = "memory"; return;
//end
//if length(S2S_getIportList_definition (s2sMain, s2sDefId))==0 then
//  sdxtype = "sensor"; return;
//end
//if length(S2S_getOportList_definition (s2sMain, s2sDefId))==0 then
//  sdxtype = "actuator"; return;
//end
//sdxtype = "algorithm";
endfunction

function ok = S2S_isSensor_definition (s2sMain, s2sDefId)
ok = length(S2S_getIportList_definition (s2sMain, s2sDefId))==0;
endfunction
function ok = S2S_isActuator_definition (s2sMain, s2sDefId)
ok = (length(S2S_getOportList_definition (s2sMain, s2sDefId))==0) &..
    ~S2S_isLogical_definition (s2sMain, s2sDefId);
endfunction

// FALSE function, moved to m4x files
// for macro code generation
//function ok = S2S_isUserDefined_definition (s2sMain, s2sDefId)
//ok = S2S_isSensor_definition (s2sMain, s2sDefId)  |..
//    S2S_isActuator_definition (s2sMain, s2sDefId) |..
//    S2S_isLogical_definition (s2sMain, s2sDefId);
//endfunction

//////////////////////////////////////////
//****** retrieve def building order ****
//////////////////////////////////////////

// args: defOrder, is a list of defId
function defOrder = _S2S_treeDrawing (s2sMain)
defOrder =_S2S_drawDagNode (s2sMain, S2S_getRootDefinitionId_main (s2sMain), list());
endfunction

function defOrder = _S2S_drawDagNode (s2sMain, defId, defOrder)
mprintf("\n\n**drawing dag node %d ", defId);

name = S2S_getFunName_definition (s2sMain, defId);
s2sDefName = S2S_getName_definition (s2sMain, defId);

if S2S_isLogical_definition (s2sMain, defId) then // logDef=> DAGNODE
  // BEFORE SCAN
  // do nothing
  clkIdList = S2S_getClkOutputIdList_logDef (s2sMain, defId);
  for i=1:length(clkIdList)
    // WHILE SCAN
    // do nothing
    clkId=clkIdList(i);
    defOrder = _S2S_drawClkEvent (s2sMain, clkId, defOrder);
  end
  // AFTER SCAN
  // add defId to the list
  defOrder($+1) = defId;
  
else // stdDef should not happen
  error("std def is not a dag node");
end
endfunction

function defOrder = _S2S_drawClkEvent (s2sMain, clkId, defOrder)
activatedBlkIdList = S2S_getOccIdList_clkEvent (s2sMain, clkId);

for occId=activatedBlkIdList
  blkId = S2S_getBlkId_occurence (s2sMain, occId);
  defOrder = _S2S_drawBlock (s2sMain, blkId, defOrder);
end
endfunction

function defOrder = _S2S_drawBlock (s2sMain, blkId, defOrder)
defId = S2S_getDefinitionId_block (s2sMain, blkId);
if S2S_isLogical_definition (s2sMain, defId) then
  defOrder = _S2S_drawDagNode (s2sMain, defId, defOrder);
end
endfunction


//*****************************************************//
//**** code generation m4x block structure ************//

//* a m4x_block has to be indexed bu its blkId and gathers all
// information needed by the code generation phase but not
// needed by the graph translation process
//* note this part is halfway between s2s structure and cpr




//*****************************************************//
//**** debug functions


function str = scanOccurences (s2sMain)
str = "\n== scanOccurences ==\n[blkId(defName)] => occId(clkId)";
nBlk = S2S_getLastBlockId_main (s2sMain)
for blkId=1:nBlk
  str = str + "\n" + msprintf("blk[%d(%s)] => ",blkId,S2S_getDefinitionName_block (s2sMain, blkId));
  occIdList = S2S_getOccIdList_block (s2sMain, blkId);
  for occId=occIdList
    clkId = S2S_getClkId_occurence (s2sMain, occId);
    str = str + msprintf("%d(%d) ",occId,clkId);
  end
end
endfunction
