//************************************************************//
//********** advanced translation trial **********************//
//************************************************************//


function s2sMain = s2s_translation (newCpr, clkMat, dataMat, clkRootId)
// init of main s2s structure
s2sMain = S2S_createVoid_main ();
s2sMain = S2S_setBlockListLength_main (s2sMain, newCpr.sim.nb);

mprintf("\n** NEW TRANSLATION PROCESS **\n*****************************\n");

 //**********************//
 //*** scsBlocks scan ***//
mprintf("*** scs blocks scan\n");
for scsId=1:S2S_getBlockListLength_main (s2sMain) // newCpr.sim.nb
  mprintf("block[%d] is ", scsId);
  
  //**** retrieve infos for definition core
  [iPortList,oPortList] = C_getPortLists (newCpr, scsId)
  funName = newCpr.sim.funs(scsId);
  s2sDef = S2S_build_defCore (funName, iPortList, oPortList); // build a minimal def
  
  //**** process for checking is definition is already present  
  //*** logical  block
  if C_blkIsLogical(newCpr, scsId) then // create blk def and scs blk (one to one relation)
    mprintf("logical ");
    
    //** creating corresponding core s2s definition and filling associated logical stuff
    //* first, set logical
    s2sDef = S2S_setLogical_defCore (s2sDef);
    
    mprintf("of name:%s \n", S2S_buildLogDefinitionName (newCpr.sim.funs(scsId), scsId));
    
    //* fill available data for log specific
    s2sDef.s2sBlockId = scsId; // pointer to corresponding scs block (1 to 1 relation)
    
    // get its future defId
    s2sDefId = S2S_getLastDefinitionId_main (s2sMain) + 1;

    //** add #nbOut clk events to it
    //* take care of clkRoot
    if scsId == clkRootId then
      s2sMain = S2S_setRootDefinitionId_main (s2sMain, s2sDefId);
      // could check some properties here
      mprintf("(clkRoot !)" );
    end

    //* get number of clkOuputs
    nbOut = C_getClkOutputPortNumber (newCpr, scsId);

    
    mprintf("it has %d clkEvt of id :",nbOut);
    for clkOutId=1:nbOut
      //* create clkEvent / linked with def s2sDefId
      clkEvt = S2S_create_clkEvent (s2sDefId);

      //* add event to main list
      s2sMain = S2S_addClkEvent_main (s2sMain, clkEvt); //s2sClkEventList($+1) = clkEvt;
      
      //* add ptr to log def
      clkEvtId = S2S_getLastClkEventId_main (s2sMain); //length(s2sClkEventList);
      s2sDef.clkOutIdList(clkOutId) = clkEvtId;
      
      mprintf("%d ",clkEvtId);
    end
    
  
    //** add def to defList (defId should be $+1)
    s2sMain = S2S_addDefinition_main (s2sMain, s2sDef); //s2sDefList(s2sDefId) = s2sDef;
    
      
  else //*** standard block 
    mprintf("standard. ");
    
    //** compute definition name (s2sDefList)
    s2sDefName = S2S_buildStdDefinitionName (funName, iPortList, oPortList); // C_getDefNameFromFuncName (newCpr, scsId)
    mprintf("it s sdxDefName is %s ",s2sDefName);
    //** look for the def if already built
    defFound = %F; currDefId = 1;
    while ~defFound & currDefId <= S2S_getLastDefinitionId_main (s2sMain) // length(s2sDefList) // look if already here

      currDefName = S2S_getName_definition (s2sMain, currDefId);
      if s2sDefName == currDefName then // already present : id = currDefId
	defFound=%T;
      else
	currDefId = currDefId + 1;
      end
    end
    if ~defFound then // if not there, set standard and add it
      s2sDef = S2S_setStandard_defCore (s2sDef);
      // fill std specific
      sdxType = C_getSdxBlkType (newCpr,scsId);
      s2sDef.defType = sdxType;
      isContinuous = C_blkIsContinuous(newCpr, scsId);
      s2sDef = S2S_setContinuous_definition (s2sDef, isContinuous);
      // add to the def list
      s2sMain = S2S_addDefinition_main (s2sMain, s2sDef); // s2sDefList($+1) = s2sDef; // add def
      // retrieve id for scsblk processing
      s2sDefId = S2S_getLastDefinitionId_main (s2sMain); // length(s2sDefList);
      mprintf("(new def, type:%s) ", sdxType);
    else // retrieve defId if found
      mprintf("(found) ");
      s2sDefId = currDefId;
    end
  end // end of std/log specific processing (definition computed)
  // here we must have s2sDefId  available for s2sBlk building
  
  //  pause;


  //*** create corresponding s2sBlock
  
  mprintf("[defId is %d]\n",s2sDefId);
  
  //** parameters for code gen taken from newCpr
  blkParamList = param_getParamValueList (newCpr, scsId);
  
  //** creating corresponding s2s block with its defId
  s2sBlk = S2S_create_block(s2sDefId, blkParamList);

  //*** adding the block to the list
  s2sMain = S2S_addBlock_definition (s2sMain, s2sBlk);// s2sBlkList(scsId) = s2sBlk; // scsId should be equal to $+1
  
  mprintf("\n");
end

mprintf("\n**** clkMat processing****\n");


//**********************//
//*** scan of clkMat ***//

// we assume std blocks get at least 1 activation.
// we assume log blocks get exactly 1 activation
// here we fill:
// *1* fill scsIdList of the activating log block 
// *2* fill clkActivationList for the activated block
// *OTHER* we build the construction order for logDefs
for i=1:size(clkMat,'r')
  clkLine = clkMat(i,:);
  srcBlkId = clkLine(1); srcPortId = clkLine(2);
  destBlkId = clkLine(3); destPortId = clkLine(4);

  mprintf("clkMat(%d)= %d|%d => %d\n",i,srcBlkId,srcPortId,destBlkId);

  logDefId = S2S_getDefinitionId_block (s2sMain, srcBlkId);
  clkEvtId = S2S_getClkOutputId_logDef (s2sMain, logDefId, srcPortId);

  // retrieve clkEvent for modifs
  clkEvt = S2S_getClkEvent_main (s2sMain, clkEvtId);
  // retrieve blk for modifs
  activatedBlk = S2S_getBlock_main (s2sMain, destBlkId);

  // create occurence, add to main and get its id
  occ = S2S_create_occurence (destBlkId, clkEvtId);
  s2sMain = S2S_addOccurence_main (s2sMain, occ);
  occId = S2S_getLastOccurenceId_main (s2sMain);
  
  //*1* add scs dest id to the current clkEvent
  clkEvt = S2S_addOccId_clkEvent (clkEvt, occId); //  clkEvt = S2S_addBlockId_clkEvent (clkEvt, destBlkId);
  // update s2sMain
  s2sMain = S2S_modifClkEvent_main (s2sMain, clkEvt, clkEvtId);
  
  //*2* fill the clkActivation list for the currently activated blk
  activatedBlk = S2S_addOccId_block (activatedBlk, occId);  //S2S_addActivationId_block (activatedBlk, clkEvtId);
  // update s2sMain
  s2sMain = S2S_modifBlock_main (s2sMain, activatedBlk, destBlkId);
end

mprintf("\n****DAG have been built****");


// mprintf(scanOccurences (s2sMain));

mprintf("\ndone.\n\n**** processing datamat ****\n");

// process datamat and fill output dependencies of src block
for i=1:size(dataMat,'r')
  dataLine = dataMat(i,:);
  dataDep = S2S_create_dataDep (dataLine(1),dataLine(2),dataLine(3),dataLine(4));
  s2sMain = S2S_addDataDep_main (s2sMain, dataDep);
  lastId = S2S_getLastDataDepId_main (s2sMain); // should be equal to 'i'
  
  mprintf("(%d,%d->%d,%d):blk %d receive outgoing dataDepId %d\n",..
      dataLine(1),dataLine(2),dataLine(3),dataLine(4),..
      dataLine(1),i);
  
  blk = S2S_getBlock_main (s2sMain, dataLine(1));
  blk = S2S_addOutDataDep_block (blk, lastId);
  s2sMain = S2S_modifBlock_main (s2sMain, blk, dataLine(1));
end


mprintf ("\ndone.\n\n**** computing data dependances ****\n");

//////////////////////////////////////////////////
///////// DATA DEPENDANCIES PROCESSING ///////////

s2sRootDefId = S2S_getRootDefinitionId_main (s2sMain);

mprintf("**** building activation path for each occurence ****\nBlock:");

// building occActivationPathList
//    occId -> (clkId list)
occActivationPathList = list(); // occId -> (clkId list)
for blkId=1:S2S_getLastBlockId_main (s2sMain)
  mprintf("\n[%d] :",blkId);
  
  occIdList = S2S_getOccIdList_block (s2sMain, blkId);

  activationTable = list();
  for i=1:length(occIdList) // multiactivation
    // get the activating clkId
    currOccId = occIdList(i);
    currClkId = S2S_getClkId_occurence (s2sMain, currOccId);  //    currClkId = clkIdList(i);
    
    // init activation path for current occurence with its activating clkId
    activationPath = list(currClkId);
    mprintf("\n  occ:%d of clkPath : %d ",currOccId, currClkId);
    // retrieve log def id
    currDefId = S2S_getDefId_clkEvent (s2sMain, currClkId);
    //  def~= rootDef, continue process until root is reached
    while currDefId ~= s2sRootDefId, // not rootDef -> store
      currClkId = S2S_getClkParentId_logDef (s2sMain, currDefId); // get clk parent
      activationPath(0) = currClkId; // append it at the beginning
      mprintf("%d ",currClkId);
      currDefId = S2S_getDefId_clkEvent (s2sMain, currClkId); // get the defId for next loop
    end
    
    // add the activation path. here : $+1 == i
    activationTable(i) = activationPath;
    
    occActivationPathList(currOccId) = activationPath;
    mprintf("\n");
  end
  mprintf(" -");
end

mprintf("\n done.\n");


//=> consistent data: we have the occActivationPathList described up there

//*********
//** INITS for data management and proxy
mprintf("\n**** initialisation of data processing structures ****\n");
// init proxy ports for each log Def (rootDef must remain void during the whole process)
for i=1:S2S_getLastDefinitionId_main (s2sMain)
  if S2S_isLogical_definition (s2sMain, i) then
    mprintf("init log def %d(%s) : ",i,S2S_getName_definition (s2sMain, i));
    s2sMain = S2S_initProxyDataList_logDef (s2sMain, i);
    mprintf("done.\n");
  end
end
// init data management for each clkEvent
for clkId=1:S2S_getLastClkEventId_main (s2sMain)
  s2sMain = S2S_initDataManagementList_clkEvent (s2sMain, clkId);
end

mprintf("\n\n******************************************************");
mprintf("\n**** building dataDep paths for each source block ****\n");
mprintf("******************************************************\n\n");

//*** for each source block, process data deps
for srcBlkId = 1:S2S_getLastBlockId_main (s2sMain)
  mprintf("\n****************************************\n");
  mprintf("***** processing src blk : %d (%s) *****\n",..
      srcBlkId, S2S_getDefinitionName_block (s2sMain, srcBlkId));
  
  //** from the output datadeps of the block, build destTable
  //** destTable is a pointer of (src)portId -> (dest)[blkId;ptId] list
  // MODIF : trial with destId instead of [blkId;ptId] list
  //** I.e : a (source) port sends its data to a list of (dest) blocks
  
  mprintf("*** building table of destinations for each o port : ");
  //* init destTable
  destTable = list();
  oPortList = S2S_getOportList_block (s2sMain, srcBlkId);
  for i=1:length(oPortList) // 1 line per o Port in the dest table
    destTable(i) = list();
  end
  //* fill destTable
  outDataDepIdList = S2S_getOutDataDepIdList_block (s2sMain, srcBlkId);
  for dataDepId=outDataDepIdList
    // get the source port id and the destination blk id
    srcPtId   = S2S_getSrcPortId_dataDep (s2sMain, dataDepId);
    
    // destBlkId = S2S_getDestBlkId_dataDep (s2sMain, dataDepId);
    // destPtId = S2S_getDestPortId_dataDep (s2sMain, dataDepId);

    // update corresponding destLine (lien:srcPtId) of destTable
    destLine = destTable(srcPtId); // the dest table of id srdPt, gets another destBlk;destPt
    destLine($+1) = dataDepId; // [destBlkId;destPtId];
    destTable(srcPtId) = destLine;
  end

 
  mprintf("done.\n");
  
 
  //=> consistent data here : for srcBlkId, we have : destTable
  //=> made of nbOports destlines,
  //=> a destLine is made of :  dataDepId list
  // (each output port send its data to 1+ (blocks,port) )
  
  //** computing NCA log def for each oPorts of srcBlk
  //** (NCA will be embedded by a dollar for remanence translation of the oPort)
  //** NCA list is : ptId -> (log) defId

  mprintf("*** processing data paths for each port\n");
  NCAdefIdlist = list();
  //* compute srcPt NCA for each destBlk (destPt does not matter)
  // (index of NCAlist and destTable is the same i.e : oPtId)
  for srcPtId=1:length(oPortList) // oPortList has already been retrieved
    dispatchDownList = list(); // clkId list
    
    mprintf("** source port %d:\n", srcPtId);
    destLine = destTable(srcPtId); // get the list of dataDep outgoing srcBlk/srcPt
    if isempty(destLine) then // no dataDep for oPort -> doing nothing
      str = msprintf("** blk %d /oPort %d have no connection !",srcBlkId,srcPtId);
      warning(str);
    else

      //***********************************
      // NCA COMPUTATION & DATA PROCESSING
      //***********************************

      //* available data
      //* srcBlkId, srcPtId
      //* destLine, destId list
      //* occActivationPathList : occId -> (clkId list)
      // note a path for occ is: list(clkRootId, . . . , occClkActivation)
      
      // mprintf('src target list: ');
      // for dataDepId=destLine
      //	bId = S2S_getDestBlkId_dataDep (s2sMain, dataDepId);
      //	bName = S2S_getDefinitionName_block (s2sMain,bId);
      //	mprintf('%d(%s) ',bId, bName);
      //      end
      mprintf("\n");
      mprintf("** partition of dest list\n");

      // the three lists elements are : destData (i.e, list(occId,ptId))
      [equalSampledDataList,subSampledDataList,destDataList] =..
	  S2S_partitionDest (s2sMain, destLine);      

      mprintf("** partition result: #equal:%d, #subSampled:%d, #others:%d\n",..
	  length(equalSampledDataList), length(subSampledDataList), length(destDataList));
      
      
      if isempty(destDataList) then // all dest are equal/under activated before a src occ
 	mprintf("\n** no NCA will be added for %d/%d (src equal/oversampled)\n",srcBlkId,srcPtId);
      else
	
	srcOccIdList = S2S_getOccIdList_block (s2sMain, srcBlkId);
	// get NCA for blocs that have exclusive or parallel activations
	[NCArowId,NCAtype] = S2S_getNca (s2sMain, occActivationPathList, srcOccIdList, destDataList);



      
	//*******************
	//** DATA PROPAGATION : no need of destination blk/pt

	//
	//____________
	//*** PART 1 : add the remanence to the correct logDef

	
	//** NCA retrieval
	//* retrieve the activation path list of source bloc
	//* retrieve the clkId of an src actPath at row NCArowId
	//  (will be the beginning of data propagation)
	ncaClkId = occActivationPathList(srcOccIdList(1))(NCArowId); // srcActivationTable(1)(NCArowId); // '1' because anyway its the good id

	//* retrieve the NCAs logDef (remanence)
	ncaLogDefId = S2S_getDefId_clkEvent (s2sMain, ncaClkId);
	//* retrieve the NCAs blkId
	ncaBlkId = S2S_getScsId_logDef (s2sMain, ncaLogDefId);

	
	mprintf("\n** NCA RESULT for srcData %d/%d :\n"+..
	    "   => clkEvt differ at row %d (type:%d)\n"+..
	    "   => ncaLogBlk:%d of def:%d in clkId:%d\n",..
	    srcBlkId, srcPtId,..
	    NCArowId, NCAtype,..
	    ncaBlkId, ncaLogDefId, ncaClkId);
	
	mprintf("** DATA PROPAGATION\n");
	mprintf("* part 1/3 : remanence processing\n");	
	//* => add blk/pt remanence to the nca logDef
	s2sMain = S2S_addProxyData_logDef (s2sMain, ncaLogDefId,..
	    srcBlkId, srcPtId, S2S_NCA_proxyType ());
	mprintf("add remanent proxydata in def : %d\n", ncaLogDefId);
	mprintf("* end of part\n");
		
	//
	//____________
	//*** PART 2 : data propagation on the activation path of each occurence
	//* carry data through hierarchy from ncaClkId until end of path (BringUp)
	// note we cannot reach this point if srcOcc.clkId = clkRoot
	mprintf("* part 2/3 : data propagation in clkPaths\n");
	for srcOccId=srcOccIdList //srcActivationTable
	  actPath = occActivationPathList(srcOccId);
	  i=NCArowId;
	  // foreach clk, bring data through the next logBlk
	  // note we cannot encounter another srcOcc during the process (exclusive)
	  while i < length(actPath) // '<' instead of '<=' because last clkId must receive a 'bringUp'
	    clkId = actPath(i); // current clkEvt
	    // retrieve the logBlk to send the data
	    nextClkId = actPath(i+1);
	    nextLogDefId = S2S_getDefId_clkEvent (s2sMain, nextClkId);
	    nextLogBlkId = S2S_getScsId_logDef (s2sMain, nextLogDefId);
	    // if not propagated yet, carry data through destLogBlkId
	    if ~S2S_isDataPropagated_clkEvent (s2sMain, clkId, srcBlkId, srcPtId) then
	      s2sMain = S2S_carryThroughData_clkEvent (s2sMain, clkId, srcBlkId, srcPtId, nextLogBlkId);
	      mprintf("add carryThrough in clkId %d to log blkId %d\n",clkId, nextLogBlkId);
	    else
	      str = msprintf("data present in clkId %d, should not happen",clkId);
	      error(str);
	    end
	    i = i + 1;
	  end
	  // last clkEvt must receive a 'bringUp'
	  clkId = S2S_getClkId_occurence (s2sMain, srcOccId) // == actPath(i) where 'i' should equal '$'
	  if ~S2S_isDataPropagated_clkEvent (s2sMain, clkId, srcBlkId, srcPtId) then	  
	    s2sMain = S2S_bringUpData_clkEvent (s2sMain, clkId, srcBlkId, srcPtId);
	    mprintf("add bringUp in clkId %d\n",clkId);
	  else
	    error ("data already propagated, should not happen");
	  end
	end // end actPath scanning
	mprintf("* end of part\n");
	
	
	//
	//____________
	//*** PART 3 : data propagation into all the brothers of clkEvt carrying data
	mprintf("* part 3/3 : propagation to clkPath brothers\n");
	for srcOccId=srcOccIdList // actPath=srcActivationTable
	  actPath = occActivationPathList(srcOccId);
	  i=NCArowId;
	  while i <= length(actPath)
	    clkId = actPath(i);
	    brotherIdList = S2S_getClkBrotherIdList_clkEvent (s2sMain, clkId); // #brothers=1 for if-then-else
	    for brotherId=brotherIdList
	      if ~S2S_dataPropagationExists_clkEvent(s2sMain, brotherId, srcBlkId, srcPtId) then // ~S2S_isDataPropagated_clkEvent (s2sMain, brotherId, srcBlkId, srcPtId) then
		s2sMain = S2S_propagateData_clkEvent (s2sMain,  brotherId, srcBlkId, srcPtId);
		mprintf("propagating data in clkId %d\n", brotherId);
	      end
	    end
	    i = i+1;
	  end	  
	end // end actPath scanning
	mprintf("* end of part\n");
	
      end // end if NCA needed
      

    
      //**************************
      //**** DATA DISPATCHING ****
      
      mprintf("** DATA DISPATCHING **\n");
      //* here we have the 3 lists of occDest : 
      //*    => equalSampledDataList,subSampledDataList,destDataList
      
      //* for equalSampledDataList, add a direct dispatchTo to their clkActivation
      mprintf("\n* part 1/3 : direct dispatchTo\n");
      for destData=equalSampledDataList
	destOcc = destData(1); destPtId = destData(2);
	clkId = S2S_getClkId_occurence (s2sMain, destOcc);
	destBlkId = S2S_getBlkId_occurence (s2sMain, destOcc);
	
	mprintf("direct dispatching to occ:%d, pt:%d (blkId:%d in clkId:%d) : ",..
	    destOcc,destPtId,destBlkId,clkId);
	s2sMain = S2S_dispatchTo_clkEvent (s2sMain,.. //*** DATA DISPATCHING ***//
	    clkId, srcBlkId, srcPtId,..
	    destBlkId, destPtId, S2S_directLink_dispatch ()); // direct dispatch data to destBlk
	mprintf("done.\n");
      end
      mprintf("* end of part\n");
	
      //** for subSampledDataList, we have to look for data upper in hierarchy 
      //   knowing there will be a srcOcc at some point
      //** note there cannot be a data propagation during the process as data does not
      //   have to be propagated here
      mprintf("\n* part 2/3 : dispatchDown to subSampled destinations\n");
      for destData=subSampledDataList
	//* first, dispatch data To blk via a local proxy port
	destOcc = destData(1); destPtId = destData(2);
	clkId = S2S_getClkId_occurence (s2sMain, destOcc);
	destBlkId = S2S_getBlkId_occurence (s2sMain, destOcc);
	mprintf("[blkId:%d/%d] (occ:%d) in clkId:%d\n",destBlkId,destPtId,destOcc,clkId);
	mprintf("a) local dispatching : ");
	s2sMain = S2S_dispatchTo_clkEvent (s2sMain,..  //*** DATA DISPATCHING ***//
	    clkId, srcBlkId, srcPtId,..
	    destBlkId, destPtId, S2S_localProxyLink_dispatch ());
	mprintf("done.\n");
	//* go up in the hierarchy and stop until an srcOcc is encountered
	// retrieve the current logBlk wich data will be brought down to
	currLogDef = S2S_getDefId_clkEvent (s2sMain, clkId);
	currLogBlk = S2S_getScsId_logDef (s2sMain, currLogDef);
	// get the clkparent to carry on the process
	clkId = S2S_getClkParentId_logDef (s2sMain, currLogDef);

	mprintf("b) dispatch down via local proxy port:\n");
	// dispatch down process
	while ~S2S_blkOccurenceExists_clkEvent (s2sMain, clkId, srcBlkId)
	  mprintf("down from clk:%d to logBlk:%d ", clkId, currLogBlk);
	  // if data not dispatched down to currLogBlk yet
	  if ~S2S_isDataDispatchedDown (s2sMain, clkId, srcBlkId, srcPtId, currLogBlk) then
	    s2sMain = S2S_dispatchDown_clkEvent (s2sMain, clkId,.. //*** DATA DISPATCHING ***//
		srcBlkId, srcPtId, currLogBlk, S2S_localProxyLink_dispatch ());
	    mprintf("(dispatch)");
	  else
	    mprintf("(NO dispatch)");
	  end
	  mprintf(" : ok\n");
	  currLogDef = S2S_getDefId_clkEvent (s2sMain, clkId);
	  currLogBlk = S2S_getScsId_logDef (s2sMain, currLogDef);
	  // get the clkparent to carry on the process
	  clkId = S2S_getClkParentId_logDef (s2sMain, currLogDef);
	end
	
	// here, an acc of srcBlkId exists -> dispatchDown logBlkId (direct)
	mprintf("c) direct dispatch down in clkId:%d to logBlk:%d ", clkId, currLogBlk);
	if ~S2S_isDataDispatchedDown (s2sMain, clkId, srcBlkId, srcPtId, currLogBlk) then
	  s2sMain = S2S_dispatchDown_clkEvent (s2sMain, clkId,.. //*** DATA DISPATCHING ***//
	      srcBlkId, srcPtId, currLogBlk, S2S_directLink_dispatch ());
	  mprintf("(dispatch)");
	else
	  mprintf("(NO dispatch)");
	end
	mprintf(" : done.\n");
      end
      mprintf("* end of part\n");

      // * Processing destDataList, the pattern is similar to subSampledDataList.
      // * Here destOcc may be :
      //     - exclusive to src
      //     - not related to src
      //     - over sampled
      mprintf("\n* part 3/3 : dispatching to others destinations (via propagation)\n");
      for destData=destDataList
	destOcc = destData(1); destPtId = destData(2);
	clkId = S2S_getClkId_occurence (s2sMain, destOcc);
	destBlkId = S2S_getBlkId_occurence (s2sMain, destOcc);
	mprintf("[blkId:%d/%d] (occ:%d) in clkId:%d\n",destBlkId,destPtId,destOcc,clkId);
	
	//* check if data is carried through or proxified via logBlk
	//  or propagated in current clkid

	// look for carried through or proxified data
	logBlkId = S2S_lookForCarryingLogBlk_clkEvent (s2sMain, clkId, srcBlkId, srcPtId);

//	if srcBlkId == 2 then pause; end
	
	////////////////// BEGIN TO DEBUG //////////////////////
	srcDataFound = %F;

	if logBlkId > 0 then // a log blk carries the data -> 
	  // dispatch data srcBlkId/srcPtId from proxy logBlkId directly to blk destBlkId/destPtId
	  s2sMain = S2S_dispatchTo_clkEvent (s2sMain,..
	      clkId, srcBlkId, srcPtId, destBlkId, destPtId, logBlkId);
	  srcDataFound = %T;
	else
	  // if data is already propagated in clkId ->
	  // data is found
	  if S2S_isDataPropagated_clkEvent (s2sMain, clkId, srcBlkId, srcPtId) then
	    srcDataFound = %T;
	  end
	  
	  // anyway, dispatch data direclty to srcBlkId/srcPtId from local port to blk destBlkId/destPtId
	  s2sMain = S2S_dispatchTo_clkEvent (s2sMain,..
	      clkId, srcBlkId, srcPtId, destBlkId, destPtId, S2S_localProxyLink_dispatch ());
	end

	
	// if nothing has been found/done => start going up in the hierarchy
	while ~srcDataFound
	  // retrieve the current logBlk wich data will be brought down to
	  currLogDef = S2S_getDefId_clkEvent (s2sMain, clkId);
	  currLogBlk = S2S_getScsId_logDef (s2sMain, currLogDef);
	  // get the new clkId (clkparent) to carry on the process
	  clkId = S2S_getClkParentId_logDef (s2sMain, currLogDef);

	  mprintf(":: up :: new clkId:%d testing blk %d(def %d)\n",clkId,currLogBlk,currLogDef);
//	  pause;
	  
	  // look for a possible logBlk
	  logBlkId = S2S_lookForCarryingLogBlk_clkEvent (s2sMain, clkId, srcBlkId, srcPtId);
	  
	  if logBlkId > 0 then // a log blk carries the data -> link from logBlk to currLogBlk
	    s2sMain = S2S_dispatchDown_clkEvent (s2sMain,..
		clkId, srcBlkId, srcPtId, currLogBlk, logBlkId);
	    srcDataFound = %T;
	  else 
	    // if data is propagated, stop the search
	    if S2S_isDataPropagated_clkEvent (s2sMain, clkId, srcBlkId, srcPtId) then
	      srcDataFound = %T;
	    end
	    // anyway, dispatch data srcBlkId/srcPtId from local proxy port to logBlk currLogBlk
	    s2sMain = S2S_dispatchDown_clkEvent (s2sMain,..
		clkId, srcBlkId, srcPtId, currLogBlk, S2S_localProxyLink_dispatch ());
	  end
	end
	
	////////////   END TO DEBUG //////////////

	
      end // end for destDataList scan
      
      mprintf("* end of part\n");
    end // end if isempty(destLine) => srcPort without connection    
  end // end foreach port
  mprintf("*** end src (%d) processing.\n", blkId);

//  pause;
end // end foreach block




mprintf("\n**** PROXY PORT PROCESSING ****\n");

//**
//** adding proxy ports to logDefIds
//**
//TODO: faire un scan des logBlocks et rajouter les proxyports requis 
//      en fct des propagations/dispatch

// this part does not respect the 'pointer way' as we have to reach data 
// into dataManagement structures
for clkId=1:S2S_getLastClkEventId_main (s2sMain)
  // get the dm list
  dmList = S2S_getDataManagementList_clkEvent (s2sMain, clkId);
  // get the related logDef from clkId
  logDefId = S2S_getDefId_clkEvent (s2sMain, clkId);

  mprintf("** clkId:%d(logDef:%d)\n",clkId,logDefId);

  for blkId=1:length(dmList)
    blkDm = dmList(blkId);
    
    for ptId=1:length(blkDm)
      dm = blkDm(ptId);
      
      // if ptId is not already 'NCA proxified', look if 'proxification' needed
      if ~S2S_hasProxyData_logDef (s2sMain, logDefId , blkId, ptId) then
	// look into 'dispatchTo' 'dispatchDown' and 'propagationMethod' to see if proxy is needed

	if ~isempty(dm.propagationMethod) then // add in AND out proxy ports for blkId/ptId
	  mprintf("blk:%d(%s) port:%d is propagated ! -> adding proxyPorts\n",blkId,S2S_getDefinitionName_block(s2sMain,blkId), ptId);
	  // add 'propagation type' proxy
	  s2sMain = S2S_addProxyData_logDef (s2sMain, logDefId,..
	      blkId, ptId, S2S_propagation_proxyType ());
	else // else look for dispatching dm
	  i=1; found=%F;
	  while i<= length(dm.dispatchToList) & ~found
	    dTo = dm.dispatchToList(i);
	    if dTo(3) == S2S_localProxyLink_dispatch () then // data comes from a local port
	      mprintf("blk:%d(%s) port:%d is dispatched ! -> adding proxyPorts\n",blkId,S2S_getDefinitionName_block(s2sMain,blkId), ptId);
	      s2sMain = S2S_addProxyData_logDef (s2sMain, logDefId,..
		  blkId, ptId,S2S_dispatching_proxyType ()); // only add an input port
	      found = %T;
	    end
	    i = i +1;
	  end
	  if ~found then
	    i = 1;
	    while i <= length(dm.dispatchDownList)
	      dDown = dm.dispatchDownList(i);
	      if dDown(2) == S2S_localProxyLink_dispatch () then // data comes from a local port
		mprintf("blk:%d(%s) port:%d is dispatched ! -> adding proxyPorts\n",blkId,S2S_getDefinitionName_block(s2sMain,blkId), ptId);
		s2sMain = S2S_addProxyData_logDef (s2sMain, logDefId,..
		    blkId, ptId,S2S_dispatching_proxyType ()); // only add an input port
		found = %T;
	      end
	      i = i +1;
	    end
	  end	  
	end // end if not is pempty dm.prop
      else
	mprintf("blk:%d(%s) port:%d already has proxy data\n",blkId,S2S_getDefinitionName_block(s2sMain,blkId), ptId);
      end // end if not has proxy data
    end // end for ports
  end // end for blocks
  mprintf("\n");
end // end for clkId
endfunction


function sdxApp = s2sMain_to_sdxApp (s2sMain)
// DAG dfs in order to retrieve the logdef construction order
mprintf("**** Depth first traversal of the DAG tree (retrieving logDef building order) ****\n");
logDefBuildOrder = _S2S_treeDrawing (s2sMain);

//////////////////////////////////////////////////
///////// CREATION DE LA STRUCTURE SDX ///////////
mprintf("\n" +..
    "***********************************\n"+..
    "**** SYNDEX STRUCTURE BUILDING ****\n"+..
    "***********************************\n\n");

// main struct
sdxApp = sdx_create_mainApp ();

// parameter list : constant whatever bloc type is used
paramList = param_getDefinitionParameterList ()

mprintf("**** creation of atomic definitions\n");
// create atomic definitions
for s2sDefId=1:S2S_getLastDefinitionId_main (s2sMain)
  if ~S2S_isLogical_definition (s2sMain, s2sDefId) then
    sdxDef  = sdx_createVoid_atomicDefinition ();
    sdxDef  = sdx_setAlgoType_definition (sdxDef,..
	S2S_getSdxType_definition (s2sMain, s2sDefId)); // TODO: pas forcment
    defName = S2S_getName_definition (s2sMain, s2sDefId);
    
    mprintf("**adding sdxdef %s(s2sdefId:%d) : ",defName,s2sDefId);
    sdxDef  = sdx_setName_definition (sdxDef, defName);
    // adding parameter names
    sdxDef = sdx_addParameters_definition (sdxDef, paramList)
    
    iPortList = S2S_getIportList_definition (s2sMain, s2sDefId);
    oPortList = S2S_getOportList_definition (s2sMain, s2sDefId);
    for pt=iPortList
      sdxDef = sdx_fastAddIport_definition (sdxDef, pt);
    end
    for pt=oPortList
      sdxDef = sdx_fastAddOport_definition (sdxDef, pt);
    end
    // add to sdx def list
    sdxApp = sdx_addDefinition_mainApp (sdxApp, sdxDef);

    // MAYBE USELESS
    // keep relation between sdx -> s2s
    sdxDefToS2sDef($+1) = sdx_getLastDefinitionId_mainApp (sdxApp);
    
    mprintf("ok.\n");
  end
end

//** Creation of definitions related to SciSyn translator
// delay definition
sdxDef = sdx_buildRemanenceDefinition ();
sdxApp = sdx_addDefinition_mainApp (sdxApp, sdxDef);

//TODO: changer pour ne pas inclure systmatiquement
// ifthel greater than zero
sdxDef = sdx_buildGtZeroDefinition ("ifthel");
sdxApp = sdx_addDefinition_mainApp (sdxApp, sdxDef);
// eselect definition
sdxDef = sdx_buildGtZeroDefinition ("eselect");
sdxApp = sdx_addDefinition_mainApp (sdxApp, sdxDef);



mprintf("****done.\n\n**** Creation of conditionned definitions\n");

//** build definitions following the order given by DFS
//** => keep rootDef for the end
for id=1 : length(logDefBuildOrder)
  currDefId = logDefBuildOrder(id);
  
  // if not root, create the conditionned def
  if currDefId == S2S_getRootDefinitionId_main (s2sMain) then
    sdxDef = sdx_createVoid_subgraphDefinition ();
  else
    sdxDef = sdx_createVoid_conditionnedDefinition ();
  end
  // set def name
  defName = S2S_getName_definition (s2sMain, currDefId);
  sdxDef = sdx_setName_definition (sdxDef,defName);

  mprintf("*** building def %d(%s)\n",currDefId, defName);
  
  //** adding proxy ports
  // get proxy list
  proxyList = S2S_getProxyDataList_logDef (s2sMain, currDefId);

  mprintf("** 1/3 : adding proxy ports\n");
  for pBlkId=1:length(proxyList)
    pBlkList = proxyList(pBlkId);
    for pBlk=pBlkList
      ptId = pBlk(1); proxyType = pBlk(2);
      
      // create proxy port for pBlkId/ptId
      dataType = "double";
      
      psize = S2S_getOportSize_block (s2sMain, pBlkId, ptId);
      iName = cmn_getProxyIportName (pBlkId, ptId);

      iPort = sdx_create_port (dataType, psize, iName);
      // in AND out ports
      if proxyType == S2S_NCA_proxyType() | proxyType == S2S_propagation_proxyType () then
	mprintf("[%d/%d] iPort AND oPort\n",pBlkId,ptId);
	oName = cmn_getProxyOportName (pBlkId, ptId);
	oPort = sdx_create_port (dataType, psize, oName);
	
	sdxDef = sdx_addIport_definition (sdxDef, iPort);
	sdxDef = sdx_addOport_definition (sdxDef, oPort);
      elseif proxyType == S2S_dispatching_proxyType () then // in only
	mprintf("[%d/%d] iPort\n",pBlkId,ptId);
	sdxDef = sdx_addIport_definition (sdxDef, iPort);
      end
    end // end pBlk scan
  end

  mprintf("\n** 2/3 : building CSG related to clkEvents\n");
  
  //*** foreach of its clkEvent, create a tmpCsg and add refs+deps
  clkIdList = S2S_getClkOutputIdList_logDef (s2sMain, currDefId);
  for condVal=1:length(clkIdList)
    //** 1: create cond
    subGraph = sdx_fastCreate_tmpCsg (condVal); // 'i' is the cond value
    clkId = clkIdList(condVal);
    
    mprintf("** Building CSG of clkId:%d\n* a) Adding references:",clkId);
    
    //** 2: add references
    occIdList = S2S_getOccIdList_clkEvent (s2sMain, clkId);
    
    for occId=occIdList
      blkId = S2S_getBlkId_occurence (s2sMain, occId);
      
      mprintf("[%d",blkId);
      // create associated reference
      defName = S2S_getDefinitionName_block (s2sMain, blkId);
      refName = S2S_getReferenceName_block (s2sMain, blkId, clkId);
      sdxRef = sdx_create_reference (defName, refName, list()); // parameters added later
  
      //* special processing for logical references : need to take care of :
      //* - data remanence
      //* - adding the '>0' bloc
      if S2S_isLogical_block (s2sMain, blkId) then
	logDefId = S2S_getDefinitionId_block (s2sMain, blkId);
	logRefName = S2S_getReferenceName_block (s2sMain, blkId, clkId);

	proxyList = S2S_getProxyDataList_logDef (s2sMain, logDefId);
	for pBlkId=1:length(proxyList)
	  proxyPortList = proxyList(pBlkId);
	  if ~isempty(proxyPortList) then
	    for proxy=proxyPortList
	      pPtId = proxy(1);
	      if S2S_hasRemanentData_logDef (s2sMain, logDefId, pBlkId, pPtId) then
		mprintf("rem %d/%d ",pBlkId, pPtId);
		// Add remanence REF
		memRefName = sdx_getRemanenceRefName (pBlkId, pPtId);
		ptSize = S2S_getOportSize_block (s2sMain, pBlkId, pPtId);
		sdxMemRef = sdx_buildRemanenceReference (pBlkId, pPtId, ptSize);
		subGraph = sdx_addRef_tmpCsg (subGraph, sdxMemRef);
		// Add link from ref oPt TO logBlkRef proxy iPort of (pBlkId/pPtId)
		proxyIname = cmn_getProxyIportName (pBlkId, pPtId);
	        sdxDep = sdx_create_dependence (memRefName,S2S_getOportName_port (1),..
		    logRefName,proxyIname);
		subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
		// add link from logBlkRef proxy oPort TO memRef iPt
		proxyOname = cmn_getProxyOportName (pBlkId, pPtId);
	        sdxDep = sdx_create_dependence (logRefName,proxyOname,.. 
		    memRefName,S2S_getIportName_port (1));		
		subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	      end // end of is remanent data
	    end // end of proxy list scan
	  end // end of if exists som proxies
	end // end of pBlkId proxies scan
      else // if not logical, adding sdx parameters
	paramList = S2S_getParameterValueList_block (s2sMain, blkId);
	sdxRef = sdx_addParameters_reference (sdxRef, paramList);
      end // end if occ logical
      //add ref to subgraph
      subGraph = sdx_addRef_tmpCsg (subGraph, sdxRef);
      mprintf("]");
    end // end of occ scan
    
    //note clkId is always available here
    
    mprintf("\n* b) adding datalinks\n");
    //** 3: add dataLinks by string
    
    // foreach data management, process proxy links/ports
    dmList = S2S_getDataManagementList_clkEvent (s2sMain, clkId);    
    for blkId=1:length(dmList)
      blkDm = dmList(blkId);
      
      currBlkName = S2S_getReferenceName_block (s2sMain, blkId, clkId);
      
      for ptId=1:length(blkDm)
	dm = blkDm(ptId);

	currOptName = S2S_getOportName_port (ptId);
	iName = cmn_getProxyIportName (blkId, ptId);
	oName = cmn_getProxyOportName (blkId, ptId);
	

	if ~(isempty(dm.dispatchToList) & isempty(dm.dispatchDownList) & isempty(dm.propagationMethod)) then
	  mprintf("[%d/%d]: ",blkId,ptId);
	

	//** dispatch srcdata blkId/ptId to :
	if ~isempty(dm.dispatchToList) then
	  mprintf("\n- dispatchTo:");
	  for dTo=dm.dispatchToList
	    targetBlk = dTo(1); targetPt = dTo(2);
	    dMethod = dTo(3);

	    mprintf("target:(%d/%d)",targetBlk,targetPt);
	    
	    blkTargetName = S2S_getReferenceName_block (s2sMain, targetBlk, clkId);
	    ptTargetName = S2S_getIportName_port (targetPt);
	    
	    //* if target port is a cond port (i.e, target blk is a logBlk)
	    //* add the gtZero operation to the dataDep
	    if S2S_isLogical_block (s2sMain, targetBlk) & targetPt == 1 then 
	      mprintf(" => condport! adding gtZero ref and datadeps\n");
	      // create the gtZero reference
	      funName =  S2S_getFunName_block (s2sMain, targetBlk);
	      sdxGtZeroRef = sdx_buildGtZeroReference (targetBlk, funName);
	      // add it to the current subgraph
	      subGraph = sdx_addRef_tmpCsg (subGraph, sdxGtZeroRef);
	      // create data Dep from sdxGtZeroRef/out to blkTargetName/ptTargetName
	      sdxDep = sdx_create_dependence (..
		  sdx_getGtZeroRefName (targetBlk),S2S_getOportName_port (1),..
		  blkTargetName,ptTargetName);
	      // add dep to the subgraph
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	      // make sdxGtZeroRef/in the new blkTargetName/ptTargetName
	      blkTargetName = sdx_getGtZeroRefName (targetBlk);
	      ptTargetName = S2S_getIportName_port (1);
	    end
	    
	    //* process dispatching according to the method
	    select dMethod,
	    case S2S_localProxyLink_dispatch () then
	      mprintf("local in clkId:%d", clkId);
	      // link from local i port to blk/pt
	      sdxDep = sdx_create_dependence (sdx_getLocalBlk_dependance(),iName,..
		  blkTargetName,ptTargetName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	      mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	    case S2S_directLink_dispatch () then
	      mprintf("direct from blk to target");
	      // link from blk/pt to targetBlk/targetPt
	      sdxDep = sdx_create_dependence (currBlkName,currOptName,..
		  blkTargetName,ptTargetName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	    mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	    else
	      mprintf("from logRef (blkId:%d)",dMethod);
	      // link from a logBlk/oport to targetBlk/targetPt
	      logBlkName = S2S_getReferenceName_block (s2sMain, dMethod, clkId);
	      sdxDep = sdx_create_dependence (logBlkName,oName,..
		  blkTargetName,ptTargetName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	      mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	    end
	    mprintf(", ");
	  end
	end
	
	//** dispatch down
	if ~isempty(dm.dispatchDownList) then
	  mprintf("\n- dispatchDown:");
	  for dDown=dm.dispatchDownList
	    logTargetBlkId = dDown(1);
	    dMethod = dDown(2);
	    logTargetName = S2S_getReferenceName_block (s2sMain, logTargetBlkId, clkId);

	    mprintf("\n[logBlk target:%d]",logTargetBlkId);
	    select dMethod,	  
	    case S2S_localProxyLink_dispatch () then
	      mprintf("local in clkId:%d", clkId);
	      // link from local/iport to logBlk iport
	      sdxDep = sdx_create_dependence (sdx_getLocalBlk_dependance (),iName,..
		  logTargetName,iName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	    case S2S_directLink_dispatch () then
	      mprintf("direct from blk");
	      // link from blkRef/ptName to logBlk iPort
	      sdxDep = sdx_create_dependence (currBlkName,currOptName,..
		  logTargetName,iName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	    else
	      mprintf("from logRef (blkId:%d)",dMethod);
	      // link from logBlk 'dMethod' oport to logTarget iport
	      logBlkName = S2S_getReferenceName_block (s2sMain, dMethod, clkId);
	      sdxDep = sdx_create_dependence (logBlkName,oName,..
		  logTargetName,iName);
	      subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	    end
	  end
	end
	
	//** data propagation
	if ~isempty(dm.propagationMethod) then
	  mprintf("\n- propagatation method : ");
	  localBlk = sdx_getLocalBlk_dependance();
	  propMethod = dm.propagationMethod;
	  select propMethod,
	  case S2S_getPropagateData_const() then
	    mprintf("propagate");
	    // propagate from local i to local o
	    sdxDep = sdx_create_dependence (localBlk,iName,localBlk,oName);
	    subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	     mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	  case S2S_getBringUpData_const () then
	    mprintf("bringUp");
	    // link from direct to local oport
	    sdxDep = sdx_create_dependence (currBlkName,currOptName,..
		localBlk,oName);
	    subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	     mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	  else // here, data is carried through logBlk 'propMethod'
	    // link from iport local to iport logblk AND
	    //           oport logblk to oport local
	    mprintf("carried through logBlk:%d",propMethod);
	    logBlkName = S2S_getReferenceName_block (s2sMain, propMethod, clkId);
	    sdxDep = sdx_create_dependence (localBlk,iName,logBlkName,iName);
	    subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	     mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	    sdxDep = sdx_create_dependence (logBlkName,oName,localBlk ,oName);
	    subGraph = sdx_addDep_tmpCsg (subGraph, sdxDep);
	     mprintf("\n[%s]", sdx_dependence_toString (sdxDep));
	  end
	end
	mprintf("\n");
	
	
        end // DEBUUUUG !
      
      end // end of ptId
    end // end of blkId
  
    // insert subGraph into definition
    mprintf("** 3/3 : inserting SG (clkId:%d) into def (defId:%d)\n",clkId,currDefId);
    sdxDef = sdx_insertTmpCsg_definition (sdxDef, subGraph);
    mprintf("** endOf clkId %d\n",clkId);
  end // end of clkId scan
    
  mprintf("*** end of log blk building %d\n", currDefId);
  
  mprintf("    addTo mainApp : ");
  sdxApp = sdx_addDefinition_mainApp (sdxApp, sdxDef);
  mprintf("done.\n\n");
  
//  pause;
end // end of logBlk scan

// last def added is rootDef
sdxRootDefId = sdx_getLastDefinitionId_mainApp (sdxApp);
sdxApp = sdx_setMainAlgoId_mainApp (sdxApp, sdxRootDefId);
// add library 'u'
sdxApp = sdx_addLibrary_mainApp (sdxApp, "u.sdx")

mprintf("\n**** syndex data structure post processing : ");
sdxApp = sdx_process_mainApp (sdxApp);
mprintf("done.\n");
endfunction
