//********************************************************
//** common definitions for syndex files


// delay definition
function sdxDef = sdx_buildRemanenceDefinition ()
sdxDef  = sdx_createVoid_atomicDefinition ();
sdxDef  = sdx_setAlgoType_definition (sdxDef,"memory");
sdxDef  = sdx_setName_definition (sdxDef, sdx_getRemanenceDefName ());
sdxDef = sdx_addParameter_definition (sdxDef, "T");
sdxDef = sdx_fastAddIport_definition (sdxDef, "T");
sdxDef = sdx_fastAddOport_definition (sdxDef, "T");
endfunction
function defName = sdx_getRemanenceDefName ()
defName = "rem"
endfunction
function memRef = sdx_buildRemanenceReference (blkId, ptId, ptSize)
memRef = sdx_create_reference (..
    sdx_getRemanenceDefName (), sdx_getRemanenceRefName (blkId, ptId), list(ptSize));
endfunction
function refName = sdx_getRemanenceRefName (blkId, ptId)
refName = msprintf("%s_%d_%d", sdx_getRemanenceDefName (), blkId, ptId);
endfunction

// args: funName is the funName of the log block. It can be ifthel or eselect
function sdxDef = sdx_buildGtZeroDefinition (funName)
sdxDef  = sdx_createVoid_atomicDefinition ();
sdxDef  = sdx_setAlgoType_definition (sdxDef,"algorithm");
sdxDef  = sdx_setName_definition (sdxDef, sdx_buildLogBlkDefName (funName));
sdxDef = sdx_fastAddIport_definition (sdxDef, 1);
// sdxDef = sdx_fastAddOport_definition (sdxDef, 1);
//* adding oport producing an integer
ptName = S2S_getOportName_port (1);
pt = sdx_create_port ("int", 1, ptName);
sdxDef = sdx_addOport_definition (sdxDef, pt);
endfunction

function sdxRef = sdx_buildGtZeroReference (logBlkId, funName)
sdxRef = sdx_create_reference (..
    sdx_buildLogBlkDefName (funName), sdx_getGtZeroRefName (logBlkId, funName), list());
endfunction
function refName = sdx_getGtZeroRefName (logBlkId, funName)
refName = msprintf("%s_%d", sdx_buildLogBlkDefName (funName),logBlkId);
endfunction

function defName = sdx_buildLogBlkDefName (funName)
defName = "test_" + funName;
endfunction